/**************************************************************
	LZSS.C -- A Data Compression Program
	(tab = 4 spaces)
***************************************************************
	4/6/1989 Haruhiko Okumura
	Use, distribute, and modify this program freely.
	Please send me your improved versions.
		PC-VAN		SCIENCE
		NIFTY-Serve	PAF01022
		CompuServe	74050,1022
**************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "lz77.h"
#include <rabbit.h>

#define FILL ' '

#ifdef FAR_LZ77
#define LZ_FAR far
unsigned char far * _lz_text_buf=(unsigned char far *)0l;
const unsigned char far * _lz_end;
#else
#define LZ_FAR
unsigned char _lz_text_buf[N];	/* ring buffer of size N, */
unsigned char LZ_FAR * _lz_end=_lz_text_buf+N;
#endif

//
// decode a single byte c
// out must be at least 18 bytes
// call first with out==NULL to init the decoder
// returns the # bytes in out
//
#ifdef FAR_LZ77
int LZ77_Decode(int c,char far * out)	/* Just the reverse of Encode(). */
#else
int LZ77_Decode(int c,char * out)	/* Just the reverse of Encode(). */
#endif
{
	char  count=0;
	static unsigned int  flags;
	static unsigned int i;
	static char state;
	static char LZ_FAR * r;
#ifdef FAR_LZ77
		if (!_lz_text_buf)
		{
			_lz_text_buf=xalloc(N);
			if (!_lz_text_buf)
				return -1;
			_lz_end=_lz_text_buf+N;
		}
#endif
	if (out==(char LZ_FAR *)0) // flag for init
	{
#ifdef FAR_LZ77
		fmemset(_lz_text_buf,FILL,N);
#else
		memset(_lz_text_buf,FILL,N);
#endif
		r = _lz_text_buf+(N-F);
		state=0;
		flags = 0;
		return 0;
	}
	for ( ; ; )
	{
		switch (state)
		{
		case 0:
			state=1;
			if (((flags >>= 1) & 256) == 0)
			{
				flags = c | 0xff00;		/* uses higher byte cleverly */
				return count;
			}							/* to count eight */
		case 1:
			if (flags & 1)
			{

				*r++ = *out = c;
				count++;
				if (r>=(char LZ_FAR *)_lz_end)
					r=_lz_text_buf;
				state=0;
				return count;
			}
			i=c;
			state=2;
			return count;
		case 2:
			{
				char k, j = c;
				i |= (((int)j & 0xf0) << 4);
				j = (j & 0x0f) + THRESHOLD;
				for (k = 0; k <= j; k++)
				{
					*out++=	*r++ = _lz_text_buf[(i + k) & (N - 1)];
					if (r>=(char LZ_FAR *)_lz_end)
						r=_lz_text_buf;
				}
				count+=j+1;
				state=0;
				return count; //count;
			}
		}
	}
}

