#define N		 4096	/* size of ring buffer */
#define F		   18	/* upper limit for match_length */
#define THRESHOLD	2   /* encode string into position and length
						   if match_length is greater than this */
#define NIL			N	/* index for root of binary search trees */

// for description refer to http://en.wikipedia.org/wiki/LZ77
//
// decode a single byte c
// out must be at least 18 bytes
// call first with out==NULL to init the decoder
// returns the # bytes in out
//
#ifdef FAR_LZ77
int LZ77_Decode(int c,char far * out);	/* Just the reverse of Encode(). */
#else
int LZ77_Decode(int c,char * out);	/* Just the reverse of Encode(). */
#endif

#ifdef _WIN32
#pragma pack(1)
#endif

typedef struct {
	char key[4];
	unsigned short CRC;
	unsigned long file_len;
	 } LZ_Header;
#ifdef _WIN32
#pragma pack()
#endif
#define LZ_KEY "LZ77"
